jQuery(document).ready(function() {

	jQuery("#generate_event_description_button").on('click', function()  {

		jQuery("#generate_event_description_button").attr("disabled", true); // Disable button while retrieving more results
		
		// Get existing content from TinyMCE editor or text editor
		if (typeof tinyMCE !== "undefined" && tinyMCE.activeEditor != null && !tinyMCE.activeEditor.isHidden()) {

			existing_content = tinymce.activeEditor.getContent();
		} else if ( jQuery('#content').length > 0 ) { 
			existing_content = jQuery('#content').val();
		}
		
		searchstring = 	document.getElementById("title").value + " " +	
						document.getElementById("EventStartDate").value + " " +
						document.getElementById("EventStartTime").value + " " +
						document.getElementById("select2-saved_tribe_venue-container").childNodes[1].textContent.trim();

		if ( searchstring.trim() === "" || document.getElementById("title").value === "" ) { 
			alert( 'Event name, date, time and venue are used to generate the description. Please fill at least the name!', 'events_optimizer' );
			jQuery("#generate_event_description_button").attr("disabled", false);// Enable button after	
		} else {							
		
			jQuery.ajax({
				type: "POST",
				url: "admin-ajax.php",
				data: { 		
					action: 'generate_event_description_with_oai', // call function "generate_event_description_with_oai"					
					_ajax_nonce: '<?php echo $nonce; ?>',
					searchstring: searchstring,
					existing_content: existing_content
				},
				beforeSend: function() {
					jQuery("body").css("cursor", "progress");						
				},
				success : function( data ) {

					info = JSON.parse( data );
					
					// Error handling
					if ( info.error ) {
						alert( info.error );
					} else {

						// Check if info.description is defined and not empty
						if (info.description && info.description.trim() !== "") {
							// Add generated description to content field (either TinymCE or text editor)
							if (typeof tinyMCE !== "undefined" && tinyMCE.activeEditor != null && !tinyMCE.activeEditor.isHidden()) {
								tinyMCE.activeEditor.setContent(info.description);
							} else if (jQuery("#content").length > 0) {
								jQuery("#content").val(info.description);
							} else {
								console.error("Unable to set content: No suitable editor or text area found");
							}
						} else {
							console.warn("Description is empty or undefined");
						}
					}
					
					jQuery("#generate_event_description_button").attr("disabled", false); // Enable button after
					jQuery("body").css("cursor", "default");
				}
			})
		}
		return false;					
	});											
});
